/*
 * 
 * DoTween24
 * This class is intended for use Tween24 in the library of Progression.
 * Copyright (c) 2010-2011 @24 (http://a24.cat)
 * 
 * 
 * Licensed under the MIT License
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 */


package a24.external.progression.commands 
{
	import a24.tween.Tween24;
	import a24.tween.Tween24Event;
	import jp.progression.commands.Command;
	import jp.progression.commands.Func;
	
	/**
	 *
	 * @author	Atsushi Kaga:@24
	 * @version	1.0
	 * @since   2011.12.13
	 * @see     http://package.a24.cat/2011/12/13/dotween24/
	 *
	 */
	public class DoTween24 extends Func
	{
		private var _tween:Tween24;
		
		/**
		 * Tween24をProgressionのコマンドとして使用します。
		 * @param	...serialTweens	再生するトゥイーンを、シリアルトゥイーンとして登録
		 */
		public function DoTween24(...serialTweens) 
		{
			_tween = Tween24.serial.apply(Tween24.serial, serialTweens);
			
			super(_tween.play, null, _tween.getDispatcher(), Tween24Event.COMPLETE, null);
		}
		
		private function _interrupt():void
		{
			_tween.stop();
		}
		
		public override function clone():Command
		{
			return new DoTween24(_tween);
		}
	}
}